function test_global ()
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

  test_init;

  src_rate = 2000;
  dst_rate = 16000;  % try upsampling by a factor 8...

  src = 1000 + sin (2*pi*20*(0:999)/src_rate);  % 0.5 s at 100 Hz (10 periods) with strong offset
  dst = enhanced_resample (src, src_rate, dst_rate);
  tgt = enhanced_resample (dst, dst_rate, src_rate);  % back...

  % show signals

  plot(1:length(src),src,'r-',1:length(tgt),tgt,'k-');

  % and error

  figure;

  plot (tgt-src);
  max (abs (tgt-src))

end
