%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.


[d,r] = wavread('../../../audio/clar.wav');
S = specgram(d,256);  % SP Toolbox routine (or use ifgram.m below)

[F, A, Ph] = spectrogram2peaks(S, r, 20);
tt = (1:size(F, 2))*128/r;  % default specgram step is NFFT/2 i.e. 128

[PM,ZM,tagM]=peaks2partialsMaq(A(:,1:floor(size(A,2)/2)),F(:,1:floor(size(A,2)/2)));
[PM2,ZM2,tagM2]=peaks2partialsMaq(A(:,floor(size(A,2)/2)+1:size(A,2)),F(:,floor(size(A,2)/2)+1:size(A,2)),tagM,ZM);
PM=[PM,PM2];
EEM=NaN * ones(tagM2,size(F,2));
for c=1:size(PM,2)
   for l=1:size(PM,1)
       if((F(l,c)~=0)&&(PM(l,c)~=0))
            EEM(PM(l,c),c)=F(l,c);
       end
   end
end

figure('Name','MAQ','NumberTitle','off')
clf
specgram(d,256,r)
colormap(1-gray)
hold on
for l=1:size(EEM,1)
    L=EEM(l,:);
    if(mod(l,7)==0)
        plot(tt,L','r');
    else if (mod(l,7)==1)
            plot(tt,L','g');
        else if (mod(l,7)==2)
            plot(tt,L','b');
            else if (mod(l,7)==3)
                plot(tt,L','c');
                else if (mod(l,7)==4)
                    plot(tt,L','m');
                    else if (mod(l,7)==5)
                        plot(tt,L','y');
                        else if (mod(l,7)==6)
                                plot(tt,L','w');
                            end
                        end
                    end
                end
            end
        end
    end
end


[PS,ZiS,ZfS,trCS,tagS]=peaks2partialsSerra2(A(:,1:floor(size(A,2)/2)),F(:,1:floor(size(F,2)/2)));
[PS2,ZiS2,ZfS2,trCS2,tagS2]=peaks2partialsSerra2(A(:,floor(size(A,2)/2)+1:size(A,2)),F(:,floor(size(A,2)/2)+1:size(A,2)),40,7,ZiS,ZfS,trCS,tagS);
PS=[PS,PS2];
EES=NaN * ones(tagS2,size(F,2));
for c=1:size(PS,2)
   for l=1:size(PS,1)
       if((F(l,c)~=0)&&(PS(l,c)~=0))
            EES(PS(l,c),c)=F(l,c);
       end
   end
end

figure('Name','Serra','NumberTitle','off')
clf
specgram(d,256,r)
colormap(1-gray)
hold on
for l=1:size(EES,1)
    L=EES(l,:);
    if(mod(l,7)==0)
        plot(tt,L','r');
    else if (mod(l,7)==1)
            plot(tt,L','g');
        else if (mod(l,7)==2)
            plot(tt,L','b');
            else if (mod(l,7)==3)
                plot(tt,L','c');
                else if (mod(l,7)==4)
                    plot(tt,L','m');
                    else if (mod(l,7)==5)
                        plot(tt,L','y');
                        else if (mod(l,7)==6)
                                plot(tt,L','w');
                            end
                        end
                    end
                end
            end
        end
    end
end

[P,Zi,Zf,trC,tag]=peaks2partialsLp(A(:,1:floor(size(A,2)/2)),F(:,1:floor(size(F,2)/2)));
[P2,Zi2,Zf2,trC2,tag2]=peaks2partialsLp(A(:,floor(size(A,2)/2)+1:size(A,2)),F(:,floor(size(A,2)/2)+1:size(A,2)),40,7,Zi,Zf,trC,tag);
P=[P,P2];
EE=NaN * ones(tag2,size(F,2));
for c=1:size(P,2)
   for l=1:size(P,1)
       if((F(l,c)~=0)&&(P(l,c)~=0))
            EE(P(l,c),c)=F(l,c);
       end
   end
end

figure('Name','Suivi par pr?diction lin?aire','NumberTitle','off')
clf
specgram(d,256,r)
colormap(1-gray)
hold on
for l=1:size(EE,1)
    L=EE(l,:);
    if(mod(l,7)==0)
        plot(tt,L','r');
    else if (mod(l,7)==1)
            plot(tt,L','g');
        else if (mod(l,7)==2)
            plot(tt,L','b');
            else if (mod(l,7)==3)
                plot(tt,L','c');
                else if (mod(l,7)==4)
                    plot(tt,L','m');
                    else if (mod(l,7)==5)
                        plot(tt,L','y');
                        else if (mod(l,7)==6)
                                plot(tt,L','w');
                            end
                        end
                    end
                end
            end
        end
    end
 end   
    
    
    
    
    

[PHF,ZiHF,ZfHF,ZaHF,trCHF,ffxHF,ffyHF,faxHF,fayHF,tagHF]=peaks2partialsHF(A(:,1:floor(size(A,2)/2)),F(:,1:floor(size(F,2)/2)),0.5,40);
[PHF2,ZiHF2,ZfHF2,ZaHF2,trCHF2,ffxHF2,ffyHF2,faxHF2,fayHF2,tagHF2]=peaks2partialsHF(A(:,floor(size(A,2)/2)+1:size(A,2)),F(:,floor(size(A,2)/2)+1:size(A,2)),0.5,40,7,ZiHF,ZfHF,ZaHF,ffxHF,ffyHF,faxHF,fayHF,trCHF,tagHF);
E=NaN * ones(tagHF2,size(F,2));
PHF=[PHF,PHF2];
for c=1:size(PHF,2)
   for l=1:size(PHF,1)
       if((F(l,c)~=0)&&(PHF(l,c)~=0))
            E(PHF(l,c),c)=F(l,c);
       end
   end
end


figure('Name','HF','NumberTitle','off')
clf
specgram(d,256,r)
colormap(1-gray)
hold on
for l=1:size(E,1)
    L=E(l,:);
    if(mod(l,7)==0)
        plot(tt,L','r');
    else if (mod(l,7)==1)
            plot(tt,L','g');
        else if (mod(l,7)==2)
            plot(tt,L','b');
            else if (mod(l,7)==3)
                plot(tt,L','c');
                else if (mod(l,7)==4)
                    plot(tt,L','m');
                    else if (mod(l,7)==5)
                        plot(tt,L','y');
                        else if (mod(l,7)==6)
                                plot(tt,L','w');
                            end
                        end
                    end
                end
            end
        end
    end
end

