function [P, Z,tag] = peaks2partialsMaq(A, F, tag, Z, deltaF)
%perform Mac Aulay and Quatieri tracking
%following 
% A : amplitude of the peaks
% F : frequency of the peaks (in Hz)
% Z : col 1 : indices
%     col 2 : freq
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

if nargin<2, [A,F]=tone2peaks();end
if nargin<4, tag=1; Z=zeros(size(F,1),2);end
if nargin<5, deltaF=40 ;end

nbTrames= size(F, 2);
nbPeaks= size(F, 1);


P=zeros(nbPeaks,nbTrames);

for t=1:nbTrames
    for p=1:nbPeaks
        for j=1:nbPeaks
            if((F(p,t)~=0)&& (Z(j,1)~=0))
                if(abs(F(p,t)-Z(j,2))<deltaF)
                    P(p,t)=Z(j,1);
                end
            end
        end
        if((P(p,t)==0) && (F(p,t)~=0))
           P(p,t)=tag;
           tag=tag+1;
        end 
    end
    Z=[ P(:,t) F(:,t)];
end

