function [ P, Zi,Zf, trameCouranteZ, tag ] = peaks2partialsSerra2( A, F, deltaF, dureeEtatZombie, Zi, Zf, trameCouranteZ, tag )
%% perform Serra tracking
%% following 
%% A : amplitude of the peaks
%% F : frequency of the peaks (in Hz)
%% dureeEtatZombie : nombre de trame sauvegarder  l'etat zombie
%% Zi : matrice de sauvegarde des indices
%% Zf : matrice de sauvegarde des frquences
%Chaque ligne de Zf,Zi  correspond  un mme partiel
%%tag : numero du dernier partiel
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.


if nargin<2, [A,F]=tone2peaks();end
if nargin<3, deltaF=40;end
if nargin<4, dureeEtatZombie=7;end
if nargin<5, Zi=zeros(size(F, 1),3);end
if nargin<6, Zf=zeros(size(F, 1),dureeEtatZombie);end
if nargin<7, trameCouranteZ=1;end
if nargin<8, tag=1;end
       
    
nbTrames= size(F, 2);
nbPeaks= size(F, 1);

P=zeros(nbPeaks,nbTrames);%matrice des indices des partiels


for t=1:nbTrames 
    
    for p=1:nbPeaks 
        for l=1:dureeEtatZombie
            for j=1:nbPeaks
                if(t-l>0)
                    if (F(p,t)==0)
                        P(p,t)=0;
                    else
                        if(abs(F(p,t)-Zf(j,mod(trameCouranteZ-l,dureeEtatZombie)+1))<deltaF)
                            P(p,t)=Zi(j,mod(trameCouranteZ-l,dureeEtatZombie)+1);
                        end
                    end
                end
            end
        end    
        if((P(p,t)==0) && (F(p,t)~=0))
           P(p,t)=tag;
           tag=tag+1;
        end 
    end
    trameCouranteZ=mod(trameCouranteZ,dureeEtatZombie)+1;
    Zf(:,trameCouranteZ)=F(:,t);
    Zi(:,trameCouranteZ)=P(:,t);

end

