function [F, A, P] = spectrogram2peaks(S, sr, nbPeaks)
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

M=abs(S);

nbFrames  = size(M, 2);

F = zeros(nbPeaks, nbFrames);
A = zeros(nbPeaks, nbFrames);
P = zeros(nbPeaks, nbFrames);
for k=1:nbFrames
    [idx, a] = quadmaxloc(M(:, k).');

    % trier a pour s?lectionner les nbPeaks plus grandes composantes
    [a, x] = sort(a, 'descend');
    f=idx(x)/(2*(size(M, 1)-1))*sr;

    if length(f)>nbPeaks;
        a=a(1:nbPeaks);
        f=f(1:nbPeaks);
    end

    F((1:length(f)), k) = f;
    A((1:length(f)), k) = a;
%    P((1:length(f)), k) = p;
end