function e = crb_epsilon (k, b, T)

% see Equation (73) of Zhou et al.,
% On Polynomial Phase Signal with Time-Varying Amplitudes,
% IEEE Trans. Sig. Proc. 44(4):848-861, 1996.
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

% assert (k >= 0);
  H = (T-1)/2;
  t = (-H:+H);
% t = (0:T-1);  % original (needed for comparison with Badeau)
  e = sum ((t/T).^k.*exp(-2*b*t/T));

end
