%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.


test_init;

N = 1024;  % frame size
Fs = 44100;  % sampling rate

a = 0.5;  % amplitude (linear)
mu = 5;  % amplitude modulation (logarithmic)
phi = pi/2;  % phase
omega = 440;  % frequency
psi = 100;  % frequency modulation

snr = 50;  % signal-to-noise ratio

% test signal
s = signal (N, Fs, a, mu, phi, omega, psi);
% additive noise
n = complex_randn (N);
n = 10^(-snr/20) * n;
% test frame
x = s + n;

% estimated parameters for the strongest spectral peak
[a_hat, mu_hat, phi_hat, omega_hat, psi_hat] = reassignment (x, Fs)

% estimated signal
s_hat = signal (N, Fs, a_hat, mu_hat, phi_hat, omega_hat, psi_hat);

% show signals
plot ((0:length(s)-1)/Fs, real(s), 'r-', (0:length(s_hat)-1)/Fs, real(s_hat), 'k-');
