%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.


clear all;
close all;
load arma2;
[s,Fs] = wavread('an_ein_on'); s = decimate(s,2); Fs = Fs / 2; s=s(6000+1:6000+round(60e-3*Fs)); s = s - mean(s);

P = 15; Q = 0;
[Y,S,Sp1] = estimation(a,b,P,Q,100);
N = length(Y);
subplot(311)
    plot((0:N/2-1)*Fs/N,10*log10(S(1:end/2)),'Color',[.5,.5,.5]);
    hold on;
    if Q>=2, plot((0:length(Sp1)-1)*Fs/(2*length(Sp1)),Sp1,'k-.'); end;
    plot((0:N/2-1)*Fs/N,10*log10(Y(1:end/2)),'k');
    hold off;
    rect = axis; rect(2:4) = [Fs/2,-80,40]; axis(rect);
    ylabel('Amplitude (dB)');
    title('(a)');

P = 8; Q = 7;
[Y,S,Sp1] = estimation(a,b,P,Q,100);
N = length(Y);
subplot(312)
    plot((0:N/2-1)*Fs/N,10*log10(S(1:end/2)),'Color',[.5,.5,.5]);
    hold on;
    if Q>=2, d = plot((0:length(Sp1)-1)*Fs/(2*length(Sp1)),Sp1,'k-.'); end;
    w = plot((0:N/2-1)*Fs/N,10*log10(Y(1:end/2)),'k');
    hold off;
    rect = axis; rect(2:4) = [Fs/2,-80,40]; axis(rect);
    legend([d,w],'Durbin','WML')
    ylabel('Amplitude (dB)');
    title('(b)');

P = 8; Q = 7;
[Y,S,Sp1] = estimation(a,b,P,Q,300);
N = length(Y);
subplot(313)
    plot((0:N/2-1)*Fs/N,10*log10(S(1:end/2)),'Color',[.5,.5,.5]);
    hold on;
    if Q>=2, d = plot((0:length(Sp1)-1)*Fs/(2*length(Sp1)),Sp1,'k-.'); end;
    w = plot((0:N/2-1)*Fs/N,10*log10(Y(1:end/2)),'k');
    hold off;
    rect = axis; rect(2:4) = [Fs/2,-80,40]; axis(rect);
    xlabel('Frequency (Hz)');
    ylabel('Amplitude (dB)');
    title('(c)');