function demo()
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

config=getConfig();

% audio file assumed to be at the WAV format and sampled at 44100 Hz
fileName = 'tmp.wav';

a = wavread('../../../audio/glockenspielShort.wav')';
b = wavread('../../../audio/maleFrenchShort.wav')';
c = wavread('../../../audio/quartetShort.wav')';

x = [a b a b c b a c];

wavwrite(x, 44100, 'tmp.wav');

ap = getAnalysisParameters();

features = getFeatures(ap, config.featureFileName, config.featuresId, [], 0);

degradationHandle={};

featuresData = computeFeaturesPerFile(fileName, features, config, ap, degradationHandle);

%save('data.mat', 'featuresData')
%load('data.mat')


for k=1:length(features.names)
   y = pdist(featuresData(features.vectorLength(k)+1:features.vectorLength(k+1), :).', 'cosine'); 
     Y = squareform(y);
Y = Y+eye(size(Y, 1))*max(y);
   imagesc(Y);
   title(features.names{k});
   disp('Press any key for the next feature...')
   pause
end

delete('tmp.wav');

