function R = ltCompute(E, ap)
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

R = zeros(ap.lt.vectorLength, size(E, 2));
for k=1:size(E, 2)
    if E(1, k) > ap.lt.order*2 && ~isnan(sum(E(:, k))) && sum(E(:, k))>0 && sum(E(:, k))<Inf
        l = E(1, k);
        f = E(2:l+1, k).';
        a = E(end/2+1:end/2+l, k).';

        % remove polynomial from amplitude data
        a=a-mean(a);
        p = polyfit((1:length(a)), a, min(ceil(length(a)/4), ap.lt.polynomOrder));
        pv = polyval(p, (1:length(a)));
        a=a-pv;

        % encode using ar models
        aa = arburg(a, ap.lt.order);
        aa = poly2lsf(aa);

        af = arburg(f, ap.lt.order);
        af = poly2lsf(af);

        R(1:end/2, k) = af;
        R(end/2+1:end, k) = aa;
    else
        R(1:end/2, k) = 0;
        R(end/2+1:end, k) = 0;
    end
end
