function E = tespecCompute(S, ap)
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

w = zeros((size(S, 1)-1)*2, 1);
h = hamming(ap.te.order*2);
%h = ones(1, ap.te.order*2);
w(1:length(h)/2) = h(end/2+1:end);
w(end-length(h)/2+1:end) = h(1:end/2);

E = zeros(ap.te.envelopeLength, size(S, 2));
for k=1:size(S, 2)
    s=S(:, k);
    a = [s(1:end-1); flipud(s(1:end-1))];

    delta=Inf;
    A=log(abs(a));
    nbIteration = 0;

    while delta>ap.te.deltaThreshold && nbIteration<ap.te.nbIteration
        % cepstral computation
        C = real(fft(w.*ifft(A)));

        %         clf
        %         hold on
        %         plot(20*log10(exp(real(A(1:end/2+1)))));
        %         plot(20*log10(exp(real(C(1:end/2+1)))), 'r');
        %         pause(.3);

        %threshold computation
        delta=exp(abs(A))-exp(abs(C));
        delta=20*log10(max(delta));

        A = max(A, C);
        nbIteration = nbIteration+1;
    end
    e=exp(real(C(1:end/2+1)));
%      clf
%      nbIteration
%          hold on
%          plot(lin2db(s))
%          plot(lin2db(e), 'r');
    E(:, k) = e(1:ap.te.envelopeLength);
end