function fvl = getFeatureVectorLength(features, ap)
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

fvl=0;
for k=1:length(features)
    switch char(features(k))
        case {'mfccearly', 'mfcc', 'mfccdelta', 'mftespec', 'mfarspec', 'mfltfspec', 'mfltaspec', 'mfltapspec', 'mfltfarspec', 'mfltaarspec', 'mfltaparspec', ...
                'ltfspecsel', 'ltaspecsel', 'ltapspecsel', 'ltaspecselm', 'ltmspecsel', 'ltmpspecsel', 'ltmspecselm', ...
                'ltfarspecsel', 'ltaarspecsel', 'ltaparspecsel', 'ltaarspecselm', 'ltmarspecsel', 'ltmparspecsel', 'ltmarspecselm'}
            featureLength = ap.mfcc.numcep;
        case 'peaks'
            featureLength = ap.peaks.nbPeaks*2;
        case {'arspec', 'tespec'}
            featureLength = ap.ar.envelopeLength;
        case {'ltf', 'lta', 'ltap', 'ltm', 'ltmp'}
            featureLength = ap.lt.vectorLength;
        case {'ltfar', 'ltaar', 'ltapar', 'ltmar', 'ltmpar'}
            featureLength = ap.lt.order;
        case {'ltfspec', 'ltaspec', 'ltapspec', 'ltamspec', 'ltmspec', 'ltmpspec', 'ltmparspec', 'ltmspec', 'ltmarspec', 'ltfarspec', 'ltaarspec', 'ltaparspec'}
            featureLength = ap.lt.nbBins;
        case {'ltfspecm', 'ltaspecm', 'ltapspecm', 'ltamspecm', 'ltmspecm', 'ltmpspecm', 'ltmspecm', 'ltfarspecm', 'ltmarspecm', 'ltaarspecm', 'ltaparspecm'}
            featureLength = ap.lt.nbBins-ap.lt.selectorStart;
        otherwise
            fprintf('unknown featureLength for feature %s, \n please fill the file getFeatureVectorLength.m', char(features(k)));
            error('');
    end
    fvl(k+1) = fvl(k)+featureLength;
end