function [spec] = invmf(cep, ap)
% [x,aspc,spec] = invmelfcc(cep, sr[, opts ...])
%    Attempt to invert plp cepstra back to a full spectrum
%    and even a waveform.  Takes all the same options as melfcc.
%    x is (noise-excited) time domain waveform; aspc is the 
%    auditory spectrogram, spec is the |STFT| spectrogram.
% 2005-05-15 dpwe@ee.columbia.edu

% Parse out the optional arguments
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.


cep = lifter(cep, ap.mfcc.lifterexp, 1);   % 3rd arg nonzero means undo liftering

% Need to reconstruct the two extra flanking bands for invpostaud to delete
% (if we're doing usecmp)

%% nbBandss
aspc = cep2spec(cep, ap.mfcc.nbands, ap.mfcc.dcttype);

% Undo the auditory spectrum (inline)
spec = invaudspec(aspc, ap.sr, ap.frameSize, ap.mfcc.fbtype, ap.mfcc.minfreq, ap.mfcc.maxfreq, ap.mfcc.sumpower, ap.mfcc.bwidth);

