function B = longtermModeling(A, F, ap, timeLine, noTracking)
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

nBands = ap.mfcc.nbands/2;

% 'Center freqs' of mel bands - uniformly spaced between limits
minmel = hz2mel(0);
maxmel = hz2mel(ap.sr/2);
binfrqs = fix(mel2hz(minmel+[0:(nBands)]/(nBands)*(maxmel-minmel))/ap.sr*ap.frameSize)+1;
subId = ones(1, nBands);

%A=A(1:ap.lt.nbBins, :);
B = zeros((max(diff(timeLine)+1)*3+1)*ap.lt.nbBands, length(timeLine)-1);

% for each segment
for k=1:length(timeLine)-1
    Ak=A(:, timeLine(k):timeLine(k+1)-1);
    AkDetection = Ak;
    R=[];
    M=[];
    for l=1:ap.lt.nbBands
        [bin indexAk] = max(sum(AkDetection, 2));
        horizon=5;
        if indexAk-horizon<1
            indexMin = 1;
        else
            indexMin = indexAk-horizon;
        end
        if indexAk+horizon>size(Ak, 1)
            indexMax = size(Ak, 1);
        else
            indexMax = indexAk+horizon;
        end

        Akl = Ak(indexMin:indexMax, :);

        indexMinBand = binfrqs(binfrqs<=indexAk);
        indexMinBand = indexMinBand(end);
        indexMaxBand = binfrqs(binfrqs>=indexAk);
        indexMaxBand = indexMaxBand(1);

        AkDetection(indexMinBand+1:indexMaxBand, :)=0;

        [Rb, Mb] = extractrax_ts(Akl);
        % take the highest magnitude element
        [bin index] = max(sum(Mb, 2));
        r = Rb(index, :);
        m = Mb(index, :);
        rf=r;
        mf=m;
        rf = colinterpvals(round(r),F(:, timeLine(k):timeLine(k+1)-1));
        mf = ifAmplitude(m, abs(round(r)-rf), ap.frameSize);

        %          clf ;
        %         subplot(2, 1, 1);
        %         hold on;
        %         plot(r, 'r');
        %         subplot(2, 1, 2);
        %         hold on;
        %         plot(m, 'r');
        %
        %         subplot(2, 1, 1);
        %         plot(rf, 'b--');
        %         subplot(2, 1, 2);
        %         plot(m, 'b--')


%        indexes = find(~isnan(rf));
%        r = rf(indexes);
%        m = mf(indexes);
r=rf;
m=mf; 
 %      indicatorR = abs(medfilt1(r, 5)-median(r));
 %       iR = sqrt(mean(indicatorR.^2));
 %       r(abs(r-median(r))>iR*.8)=NaN;
        % indicatorM = abs(medfilt1(m, 5)-median(m));
        %iM = sqrt(mean(indicatorM.^2))
        %m(abs(m-median(m))>iM*1)=NaN;

        mn = Ak(indexAk, :);
        %[r m, mn] = removeNans(r, m, mn);
        %indexes = find(~isnan(r));
        %r = r(indexes);
        %m = m(indexes);
       % r=r-mean(r);
       % m=(m-mean(m));
       % mn=(mn-mean(mn));


        R=[R length(mn) mn mn mn];
        % M=[M ];

        %         figure(1); plot(R);
        %         figure(2) ; plot(M);
        %          figure(3); plot(log10(abs(fft(R))));
        %         figure(4) ; plot(log10(abs(fft(M))));
    end
    l = length(R);
    B(1:l, k) = R;
    % B(end/2+1:end/2+l, k) = M;
end

function [v, v2, v3] = removeNans(v, v2, v3)

startIndex=1;
endIndex = length(v);
for k=1:length(v)
    if startIndex==k && isnan(v(k))
        startIndex=startIndex+1;
    else
        break;
    end
end
for k=length(v):-1:1
    if endIndex==k && isnan(v(k))
        endIndex=endIndex-1;
    else
        break;
    end
end
v=v(startIndex:endIndex);
v(isnan(v))=0;
v2=v2(startIndex:endIndex);
v2(isnan(v2))=0;
v3=v3(startIndex:endIndex);
v3(isnan(v2))=0;
