%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

clear all;
close all;
Fs = 22000;
I = 1000;
L = 88;
J = 4;

% Signal de test
N = I;
f1 = 440/Fs*N;
f2 = 660/Fs*N;
f3 = 330/Fs*N;
f4 = 550/Fs*N;
Y = zeros(N,1); 
Y(1+f1:f1:N/2) = Y(1+f1:f1:N/2) + 10^(-10/20)* abs(exp(-i*2*pi*(f1:f1:N/2-1)'*(0:2-1)/N) * [1; 0.9]/1.9) .* exp(2*pi*i*rand(size(Y(1+f1:f1:N/2))));
Y(1+f2:f2:N/2) = Y(1+f2:f2:N/2) + 10^(-0/20) * abs(exp(-i*2*pi*(f2:f2:N/2-1)'*(0:3-1)/N) * [1; 0.9; 0.8]/2.7) .* exp(2*pi*i*rand(size(Y(1+f2:f2:N/2))));
Y(1+f3:f3:N/2) = Y(1+f3:f3:N/2) + 10^(-30/20) * abs(exp(-i*2*pi*(f3:f3:N/2-1)'*(0:4-1)/N) * [1; 0.9; 0.8; 0.7]/3.4) .* exp(2*pi*i*rand(size(Y(1+f3:f3:N/2))));
Y(1+f4:f4:N/2) = Y(1+f4:f4:N/2) + 10^(-20/20) * abs(exp(-i*2*pi*(f4:f4:N/2-1)'*(0:5-1)/N) * [1; 0.9; 0.8; 0.7; 0.6]/4) .* exp(2*pi*i*rand(size(Y(1+f4:f4:N/2))));
y = 2*real(ifft(Y))*sqrt(N);
y = y + 10^(-60/20)* (randn(N,1)+i*randn(N,1))/sqrt(2);
Y = abs(fft(y)).^2/N;
plot((0:N/2-1)/N*Fs,10*log10(Y(1:N/2)));
xlabel('Frequency (Hz)');
ylabel('Magnitude (dB)');
axis([0,Fs/2,-80,0]);

% Initialisation de l'estimateur de pitch

f0 = round(440*2.^(((1:88)-49)/12) / Fs * N); %  partir de la note midi n37;
h = zeros(I,length(f0));
for k=1:length(f0),
    for f = 1+f0(k):f0(k):N/2,
        h(f,k) = 1;
    end;
end;
h(I/2+2:I,:) = h(I/2:-1:2,:);


% Algorithme EM
l = [44,49+12,53+5,56];
[l,s,X2,lambda] = EM(Y, I, [], h, 4,[],l,f0/N*Fs,Fs);